Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintConstOptEvaluator.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintConstOptEvaluator.cs	(revision 17369)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintConstOptEvaluator.cs	(revision 17370)
@@ -94,6 +94,5 @@
         if (!constraint.IsDerivation) {
           var res = intervalInterpreter.GetSymbolicExpressionTreeInterval(solution, variableRanges);
-          if (!constraint.Interval.Contains(res, constraint.InclusiveLowerBound,
-            constraint.InclusiveUpperBound)) {
+          if (!constraint.Interval.Contains(res)) {
             return true;
           }
@@ -104,6 +103,5 @@
           }
           var res = intervalInterpreter.GetSymbolicExpressionTreeInterval(tree, variableRanges);
-          if (!constraint.Interval.Contains(res, constraint.InclusiveLowerBound,
-            constraint.InclusiveUpperBound)) {
+          if (!constraint.Interval.Contains(res)) {
             return true;
           }
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/SymbolicRegressionConstraintAnalyzer.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/SymbolicRegressionConstraintAnalyzer.cs	(revision 17369)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/SymbolicRegressionConstraintAnalyzer.cs	(revision 17370)
@@ -115,5 +115,5 @@
       }
 
-      var satisfied = constraint.Interval.Contains(resultInterval, constraint.InclusiveLowerBound, constraint.InclusiveUpperBound);
+      var satisfied = constraint.Interval.Contains(resultInterval);
       return satisfied;
     }
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.Designer.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.Designer.cs	(revision 17369)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.Designer.cs	(revision 17370)
@@ -47,6 +47,4 @@
       this.lowerboundLabel = new System.Windows.Forms.Label();
       this.upperboundLabel = new System.Windows.Forms.Label();
-      this.incllowerboundLabel = new System.Windows.Forms.Label();
-      this.inclupperboundLabel = new System.Windows.Forms.Label();
       this.variableLabel = new System.Windows.Forms.Label();
       this.numberderivationLabel = new System.Windows.Forms.Label();
@@ -55,4 +53,5 @@
       this.variableInput = new System.Windows.Forms.TextBox();
       this.groupBox1 = new System.Windows.Forms.GroupBox();
+      this.enabledLabel = new System.Windows.Forms.Label();
       this.label1 = new System.Windows.Forms.Label();
       this.numberderivationInput = new System.Windows.Forms.ComboBox();
@@ -60,8 +59,5 @@
       this.expressionInput = new System.Windows.Forms.TextBox();
       this.expressionLabel = new System.Windows.Forms.Label();
-      this.inclupperboundInput = new System.Windows.Forms.CheckBox();
-      this.incllowerboundInput = new System.Windows.Forms.CheckBox();
       this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
-      this.enabledLabel = new System.Windows.Forms.Label();
       this.groupBox1.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
@@ -73,5 +69,5 @@
       this.lowerboundLabel.Location = new System.Drawing.Point(8, 101);
       this.lowerboundLabel.Name = "lowerboundLabel";
-      this.lowerboundLabel.Size = new System.Drawing.Size(69, 13);
+      this.lowerboundLabel.Size = new System.Drawing.Size(90, 17);
       this.lowerboundLabel.TabIndex = 2;
       this.lowerboundLabel.Text = "Lowerbound:";
@@ -82,25 +78,7 @@
       this.upperboundLabel.Location = new System.Drawing.Point(8, 126);
       this.upperboundLabel.Name = "upperboundLabel";
-      this.upperboundLabel.Size = new System.Drawing.Size(69, 13);
+      this.upperboundLabel.Size = new System.Drawing.Size(91, 17);
       this.upperboundLabel.TabIndex = 3;
       this.upperboundLabel.Text = "Upperbound:";
-      // 
-      // incllowerboundLabel
-      // 
-      this.incllowerboundLabel.AutoSize = true;
-      this.incllowerboundLabel.Location = new System.Drawing.Point(8, 153);
-      this.incllowerboundLabel.Name = "incllowerboundLabel";
-      this.incllowerboundLabel.Size = new System.Drawing.Size(92, 13);
-      this.incllowerboundLabel.TabIndex = 4;
-      this.incllowerboundLabel.Text = "Incl. Lowerbound:";
-      // 
-      // inclupperboundLabel
-      // 
-      this.inclupperboundLabel.AutoSize = true;
-      this.inclupperboundLabel.Location = new System.Drawing.Point(8, 178);
-      this.inclupperboundLabel.Name = "inclupperboundLabel";
-      this.inclupperboundLabel.Size = new System.Drawing.Size(92, 13);
-      this.inclupperboundLabel.TabIndex = 5;
-      this.inclupperboundLabel.Text = "Incl. Upperbound:";
       // 
       // variableLabel
@@ -109,5 +87,5 @@
       this.variableLabel.Location = new System.Drawing.Point(8, 47);
       this.variableLabel.Name = "variableLabel";
-      this.variableLabel.Size = new System.Drawing.Size(48, 13);
+      this.variableLabel.Size = new System.Drawing.Size(64, 17);
       this.variableLabel.TabIndex = 7;
       this.variableLabel.Text = "Variable:";
@@ -118,5 +96,5 @@
       this.numberderivationLabel.Location = new System.Drawing.Point(8, 74);
       this.numberderivationLabel.Name = "numberderivationLabel";
-      this.numberderivationLabel.Size = new System.Drawing.Size(65, 13);
+      this.numberderivationLabel.Size = new System.Drawing.Size(84, 17);
       this.numberderivationLabel.TabIndex = 8;
       this.numberderivationLabel.Text = "#Derivation:";
@@ -128,5 +106,5 @@
       this.upperboundInput.Location = new System.Drawing.Point(108, 123);
       this.upperboundInput.Name = "upperboundInput";
-      this.upperboundInput.Size = new System.Drawing.Size(473, 20);
+      this.upperboundInput.Size = new System.Drawing.Size(473, 22);
       this.upperboundInput.TabIndex = 11;
       this.upperboundInput.Validating += new System.ComponentModel.CancelEventHandler(this.upperboundInput_Validating);
@@ -139,5 +117,5 @@
       this.lowerboundInput.Location = new System.Drawing.Point(108, 98);
       this.lowerboundInput.Name = "lowerboundInput";
-      this.lowerboundInput.Size = new System.Drawing.Size(473, 20);
+      this.lowerboundInput.Size = new System.Drawing.Size(473, 22);
       this.lowerboundInput.TabIndex = 12;
       this.lowerboundInput.Validating += new System.ComponentModel.CancelEventHandler(this.lowerboundInput_Validating);
@@ -150,5 +128,5 @@
       this.variableInput.Location = new System.Drawing.Point(108, 44);
       this.variableInput.Name = "variableInput";
-      this.variableInput.Size = new System.Drawing.Size(473, 20);
+      this.variableInput.Size = new System.Drawing.Size(473, 22);
       this.variableInput.TabIndex = 15;
       // 
@@ -161,6 +139,4 @@
       this.groupBox1.Controls.Add(this.expressionInput);
       this.groupBox1.Controls.Add(this.expressionLabel);
-      this.groupBox1.Controls.Add(this.inclupperboundInput);
-      this.groupBox1.Controls.Add(this.incllowerboundInput);
       this.groupBox1.Controls.Add(this.variableInput);
       this.groupBox1.Controls.Add(this.lowerboundInput);
@@ -168,6 +144,4 @@
       this.groupBox1.Controls.Add(this.numberderivationLabel);
       this.groupBox1.Controls.Add(this.variableLabel);
-      this.groupBox1.Controls.Add(this.inclupperboundLabel);
-      this.groupBox1.Controls.Add(this.incllowerboundLabel);
       this.groupBox1.Controls.Add(this.upperboundLabel);
       this.groupBox1.Controls.Add(this.lowerboundLabel);
@@ -180,4 +154,13 @@
       this.groupBox1.Text = "Interval Constraints Detail";
       // 
+      // enabledLabel
+      // 
+      this.enabledLabel.AutoSize = true;
+      this.enabledLabel.Location = new System.Drawing.Point(8, 153);
+      this.enabledLabel.Name = "enabledLabel";
+      this.enabledLabel.Size = new System.Drawing.Size(64, 17);
+      this.enabledLabel.TabIndex = 29;
+      this.enabledLabel.Text = "Enabled:";
+      // 
       // label1
       // 
@@ -185,5 +168,5 @@
       this.label1.Location = new System.Drawing.Point(11, -105);
       this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(49, 13);
+      this.label1.Size = new System.Drawing.Size(64, 17);
       this.label1.TabIndex = 28;
       this.label1.Text = "Enabled:";
@@ -196,5 +179,5 @@
       this.numberderivationInput.Location = new System.Drawing.Point(108, 71);
       this.numberderivationInput.Name = "numberderivationInput";
-      this.numberderivationInput.Size = new System.Drawing.Size(473, 21);
+      this.numberderivationInput.Size = new System.Drawing.Size(473, 24);
       this.numberderivationInput.TabIndex = 27;
       this.numberderivationInput.SelectedIndexChanged += new System.EventHandler(this.numberderivationInput_SelectedIndexChanged);
@@ -203,7 +186,7 @@
       // 
       this.ischeckedCheckBox.AutoSize = true;
-      this.ischeckedCheckBox.Location = new System.Drawing.Point(108, 200);
+      this.ischeckedCheckBox.Location = new System.Drawing.Point(108, 154);
       this.ischeckedCheckBox.Name = "ischeckedCheckBox";
-      this.ischeckedCheckBox.Size = new System.Drawing.Size(15, 14);
+      this.ischeckedCheckBox.Size = new System.Drawing.Size(18, 17);
       this.ischeckedCheckBox.TabIndex = 26;
       this.ischeckedCheckBox.UseVisualStyleBackColor = true;
@@ -216,5 +199,5 @@
       this.expressionInput.Location = new System.Drawing.Point(108, 19);
       this.expressionInput.Name = "expressionInput";
-      this.expressionInput.Size = new System.Drawing.Size(473, 20);
+      this.expressionInput.Size = new System.Drawing.Size(473, 22);
       this.expressionInput.TabIndex = 25;
       // 
@@ -224,41 +207,12 @@
       this.expressionLabel.Location = new System.Drawing.Point(8, 22);
       this.expressionLabel.Name = "expressionLabel";
-      this.expressionLabel.Size = new System.Drawing.Size(61, 13);
+      this.expressionLabel.Size = new System.Drawing.Size(81, 17);
       this.expressionLabel.TabIndex = 24;
       this.expressionLabel.Text = "Expression:";
       // 
-      // inclupperboundInput
-      // 
-      this.inclupperboundInput.AutoSize = true;
-      this.inclupperboundInput.Location = new System.Drawing.Point(108, 177);
-      this.inclupperboundInput.Name = "inclupperboundInput";
-      this.inclupperboundInput.Size = new System.Drawing.Size(15, 14);
-      this.inclupperboundInput.TabIndex = 23;
-      this.inclupperboundInput.UseVisualStyleBackColor = true;
-      this.inclupperboundInput.CheckedChanged += new System.EventHandler(this.inclupperboundInput_CheckedChanged);
-      // 
-      // incllowerboundInput
-      // 
-      this.incllowerboundInput.AutoSize = true;
-      this.incllowerboundInput.Location = new System.Drawing.Point(108, 153);
-      this.incllowerboundInput.Name = "incllowerboundInput";
-      this.incllowerboundInput.Size = new System.Drawing.Size(15, 14);
-      this.incllowerboundInput.TabIndex = 22;
-      this.incllowerboundInput.UseVisualStyleBackColor = true;
-      this.incllowerboundInput.CheckedChanged += new System.EventHandler(this.incllowerboundInput_CheckedChanged);
-      // 
       // errorProvider
       // 
       this.errorProvider.ContainerControl = this;
       this.errorProvider.RightToLeft = true;
-      // 
-      // enabledLabel
-      // 
-      this.enabledLabel.AutoSize = true;
-      this.enabledLabel.Location = new System.Drawing.Point(8, 200);
-      this.enabledLabel.Name = "enabledLabel";
-      this.enabledLabel.Size = new System.Drawing.Size(49, 13);
-      this.enabledLabel.TabIndex = 29;
-      this.enabledLabel.Text = "Enabled:";
       // 
       // IntervalConstraintView
@@ -278,6 +232,4 @@
     private System.Windows.Forms.Label lowerboundLabel;
     private System.Windows.Forms.Label upperboundLabel;
-    private System.Windows.Forms.Label incllowerboundLabel;
-    private System.Windows.Forms.Label inclupperboundLabel;
     private System.Windows.Forms.Label variableLabel;
     private System.Windows.Forms.Label numberderivationLabel;
@@ -286,6 +238,4 @@
     private System.Windows.Forms.TextBox variableInput;
     private System.Windows.Forms.GroupBox groupBox1;
-    private System.Windows.Forms.CheckBox inclupperboundInput;
-    private System.Windows.Forms.CheckBox incllowerboundInput;
     private System.Windows.Forms.TextBox expressionInput;
     private System.Windows.Forms.Label expressionLabel;
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.cs	(revision 17369)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.cs	(revision 17370)
@@ -64,6 +64,4 @@
       lowerboundInput.Enabled = Content != null && !Locked && !ReadOnly;
       upperboundInput.Enabled = Content != null && !Locked && !ReadOnly;
-      incllowerboundInput.Enabled = Content != null && !Locked && !ReadOnly;
-      inclupperboundInput.Enabled = Content != null && !Locked && !ReadOnly;
       ischeckedCheckBox.Enabled = Content != null && !Locked && !ReadOnly;
     }
@@ -99,6 +97,4 @@
         lowerboundInput.Text = string.Empty;
         upperboundInput.Text = string.Empty;
-        incllowerboundInput.Checked = true;
-        inclupperboundInput.Checked = true;
         return;
       }
@@ -107,6 +103,5 @@
       lowerboundInput.Text = Content.Interval.LowerBound.ToString();
       upperboundInput.Text = Content.Interval.UpperBound.ToString();
-      incllowerboundInput.Checked = Content.InclusiveLowerBound;
-      inclupperboundInput.Checked = Content.InclusiveUpperBound;
+
       variableInput.Text = Content.Variable;
       if (!Content.IsDerivation) {
@@ -177,12 +172,4 @@
     }
 
-    private void incllowerboundInput_CheckedChanged(object sender, EventArgs e) {
-        Content.InclusiveLowerBound = incllowerboundInput.Checked;
-    }
-
-    private void inclupperboundInput_CheckedChanged(object sender, EventArgs e) {
-        Content.InclusiveUpperBound = inclupperboundInput.Checked;
-    }
-
     private void ischeckedCheckBox_CheckedChanged(object sender, EventArgs e) {
         Content.Enabled = ischeckedCheckBox.Checked;
@@ -192,4 +179,5 @@
       if (numberderivationInput.SelectedItem == null) { 
         Content.NumberOfDerivation = 0;
+        numberderivationInput.Enabled = false;
         return;
       }
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/ProblemDataConstraintView.designer.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/ProblemDataConstraintView.designer.cs	(revision 17369)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/ProblemDataConstraintView.designer.cs	(revision 17370)
@@ -143,11 +143,10 @@
                          "3. Add the keyword in" + Environment.NewLine +
                          "4. Specify the interval with [lowerbound .. upperbound]" + Environment.NewLine +
-                         "5. Open or closed square brackets denotes if an interval is open or closed" + Environment.NewLine + Environment.NewLine +
                          "To define a derivation constraint: " + Environment.NewLine +
                          "1. Start with d or \u2202" + Environment.NewLine +
                          "2. Specify the target between '-characters" + Environment.NewLine +
-                         "3. Seperate taget and derivation variable with /" + Environment.NewLine +
+                         "3. Separate target and derivation variable with /" + Environment.NewLine +
                          "4. Add derivation variable between '-characters'" + Environment.NewLine +
-                         "5. Follow the steps 3-5 from above";
+                         "5. Follow the steps 3-4 from above";
       // 
       // intervalConstraintsView
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs	(revision 17369)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs	(revision 17370)
@@ -71,39 +71,9 @@
     }
 
-    public bool Contains(Interval other, bool lowerBoundInclusive = true, bool upperBoundInclusive = false) {
-      if (double.IsNegativeInfinity(this.LowerBound) && double.IsPositiveInfinity(this.UpperBound))
-        return true;
-      //Left-unbounded and right-bounded:
-      if (double.IsNegativeInfinity(this.LowerBound)) {
-        if (upperBoundInclusive)
-          return other.LowerBound <= this.UpperBound && other.UpperBound <= this.UpperBound;
-        return other.LowerBound < this.UpperBound && other.UpperBound < this.UpperBound;
-      }
-
-      //Left-bounded and right-unbounded:
-      if (double.IsPositiveInfinity(this.UpperBound)) {
-        if (lowerBoundInclusive)
-          return other.LowerBound >= this.LowerBound && other.UpperBound >= this.LowerBound;
-        return other.LowerBound > this.LowerBound && other.UpperBound > this.LowerBound;
-      }
-
-      //Proper and bounded:
-      //Closed:
-      if (lowerBoundInclusive && upperBoundInclusive) {
-        return this.LowerBound <= other.LowerBound && other.UpperBound <= this.UpperBound;
-      }
-
-      //Open:
-      if (!lowerBoundInclusive && !upperBoundInclusive) {
-        return this.LowerBound < other.LowerBound && other.UpperBound < this.UpperBound;
-      }
-
-      //Left-closed, right-open:
-      if (lowerBoundInclusive) {
-        return this.LowerBound <= other.LowerBound && other.UpperBound < this.UpperBound;
-      }
-
-      //Left-open, right-closed:
-      return this.LowerBound < other.LowerBound && other.UpperBound <= this.UpperBound;
+    public bool Contains(Interval other) {
+      if (double.IsNegativeInfinity(LowerBound) && double.IsPositiveInfinity(UpperBound)) return true;
+      if (other.LowerBound >= LowerBound && other.UpperBound <= UpperBound) return true;
+  
+      return false;
     }
 
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraint.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraint.cs	(revision 17369)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraint.cs	(revision 17370)
@@ -98,28 +98,4 @@
 
     [Storable]
-    private bool inclusiveLowerBound;
-    public bool InclusiveLowerBound {
-      get => inclusiveLowerBound;
-      set {
-        if (inclusiveLowerBound == value) return;
-        inclusiveLowerBound = value;
-        UpdateExpression();
-        OnChanged();
-      }
-    }
-
-    [Storable]
-    private bool inclusiveUpperBound;
-    public bool InclusiveUpperBound {
-      get => inclusiveUpperBound;
-      set {
-        if (inclusiveUpperBound == value) return;
-        inclusiveUpperBound = value;
-        UpdateExpression();
-        OnChanged();
-      }
-    }
-
-    [Storable]
     private bool enabled;
     public bool Enabled {
@@ -135,6 +111,5 @@
     private IntervalConstraint(StorableConstructorFlag _) : base(_) { }
 
-    public IntervalConstraint(string expression, string variable, string target, int numberOfDerivation, Interval interval, bool inclusiveLowerBound,
-      bool inclusiveUpperBound, bool enabled) : base(){
+    public IntervalConstraint(string expression, string variable, string target, int numberOfDerivation, Interval interval, bool enabled) : base(){
       this.expression = expression;
       this.variable = variable;
@@ -142,6 +117,4 @@
       this.numberOfDerivation = numberOfDerivation;
       this.interval = interval;
-      this.inclusiveLowerBound = inclusiveLowerBound;
-      this.inclusiveUpperBound = inclusiveUpperBound;
       this.enabled = enabled;
     }
@@ -158,6 +131,4 @@
       this.NumberOfDerivation = original.NumberOfDerivation;
       this.Interval = original.Interval;
-      this.InclusiveLowerBound = original.InclusiveLowerBound;
-      this.InclusiveUpperBound = original.InclusiveUpperBound;
       this.Enabled = original.Enabled;
     }
@@ -189,8 +160,8 @@
         expression = string.Format("Target:{0} in {1}{2} .. {3}{4}",
           Variable,
-          (InclusiveLowerBound) ? "[" : "]",
+          "[",
           Interval?.LowerBound,
           Interval?.UpperBound,
-          (InclusiveUpperBound) ? "]" : "[");
+          "]");
         Expression = expression;
         return;
@@ -199,8 +170,8 @@
         Variable,
         Target,
-        (InclusiveLowerBound) ? "[" : "]",
+        "[",
         Interval?.LowerBound,
         Interval?.UpperBound,
-        (InclusiveUpperBound) ? "]" : "[",
+        "]",
         GetDerivationString(numberOfDerivation));
         Expression = expression;
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraintsParser.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraintsParser.cs	(revision 17369)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraintsParser.cs	(revision 17370)
@@ -33,5 +33,5 @@
       if (string.IsNullOrEmpty(target)) throw new ArgumentNullException("No target variable has been provided.");
       if (variables == null) throw new ArgumentNullException("No variables have been provided.");
-      if (!variables.Any()) throw new ArgumentException("Varialbes are empty.");
+      if (!variables.Any()) throw new ArgumentException("Variables are empty.");
 
       var lines = inputText.Split(new[] { "\r\n", "\r", "\n" }, StringSplitOptions.None);
@@ -44,5 +44,5 @@
           var targetConstraint = trimmedLine.Substring(start, end - start);
           var match = Regex.Match(targetConstraint,
-            @"(['](.*)[']|(.*[^\s]))\s*(\bin\b)\s*([\[\]])\s*(\S*)\s*(\.{2})\s*(\S*)\s*([\[\]])");
+            @"(['](.*)[']|(.*[^\s]))\s*(\bin\b)\s*([\[])\s*(\S*)\s*(\.{2})\s*(\S*)\s*([\]])");
           if (match.Success) {
             if (match.Groups.Count != 10) {
@@ -63,11 +63,9 @@
               var parsedTarget = match.Groups[1].Value.Trim();
               var variable = targetVariable;
-              var inclLowerBound = match.Groups[5].Value.Trim() == "[";
-              var inclUpperBound = match.Groups[9].Value.Trim() == "]";
               var isEnabled = true;
               var numberOfDerivation = 0;
               var interval = new Interval(lowerBound, upperBound);
 
-              var constraint = new IntervalConstraint(expression, variable, parsedTarget, numberOfDerivation, interval, inclLowerBound, inclUpperBound, isEnabled);
+              var constraint = new IntervalConstraint(expression, variable, parsedTarget, numberOfDerivation, interval, isEnabled);
 
               yield return constraint;
@@ -79,5 +77,5 @@
         } else if (trimmedLine.StartsWith("d") || trimmedLine.StartsWith("\u2202")) {
           var match = Regex.Match(trimmedLine,
-            @"([d∂])([²³]?)\s*(['](.*)[']|(.*[^\s]))\s*(\/)\s*([d∂])\s*(['](.*)[']|(.*[^\s²³]))\s*([²³]?)\s*\bin\b\s*([\[\]])\s*(\S*)\s*(\.{2})\s*(\S*)\s*([\[\]])");
+            @"([d∂])([²³]?)\s*(['](.*)[']|(.*[^\s]))\s*(\/)\s*([d∂])\s*(['](.*)[']|(.*[^\s²³]))\s*([²³]?)\s*\bin\b\s*([\[])\s*(\S*)\s*(\.{2})\s*(\S*)\s*([\]])");
 
           if (match.Success) {
@@ -115,11 +113,9 @@
               var parsedTarget = derivationTarget;
               var isEnabled = true;
-              var inclLowerBound = match.Groups[12].Value.Trim() == "[";
-              var inclUpperBound = match.Groups[16].Value.Trim() == "]";
               var variable = derivationVariable;
               var numberOfDerivation = ParseDerivationCount(match.Groups[2].Value.Trim());
               var interval = new Interval(lowerBound, upperBound);
 
-              var constraint = new IntervalConstraint(expression, variable, parsedTarget, numberOfDerivation, interval, inclLowerBound, inclUpperBound, isEnabled);
+              var constraint = new IntervalConstraint(expression, variable, parsedTarget, numberOfDerivation, interval, isEnabled);
 
               yield return constraint;
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/ProblemDataConstraint.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/ProblemDataConstraint.cs	(revision 17369)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/ProblemDataConstraint.cs	(revision 17370)
@@ -37,5 +37,5 @@
                                                   "# Example for constraint on model parameter: " + Environment.NewLine +
                                                   "d'y'/d'x' in [0 .. 10]" + Environment.NewLine +
-                                                  "∂²'y'/∂'x'² in ]-1 .. inf.[";
+                                                  "∂²'y'/∂'x'² in [-1 .. inf.]";
 
     [Storable]